var _NewsFeedGadget = new NewsFeedGadget();
var rss = null;


function PrepareControlCore(path, rootCls, rootPid, rootTypeLib, clsid, prgid, dllname, name, typelib)
{
    var wshShell = new ActiveXObject("WScript.Shell"); 
    
    try{
    wshShell.RegDelete (rootCls+"InprocServer32\\");
    }catch(e){}
    
    wshShell.RegWrite (rootPid, name);
    wshShell.RegWrite (rootPid+"CLSID\\", "{"+clsid+"}");
    wshShell.RegWrite (rootCls, prgid);
    wshShell.RegWrite (rootCls+"InprocServer32\\", path);
    wshShell.RegWrite (rootCls+"InprocServer32\\ThreadingModel", "Apartment");
    wshShell.RegWrite (rootCls+"Implemented Categories\\{7DD95801-9882-11CF-9FA9-00AA006C42C4}\\", "");
    wshShell.RegWrite (rootCls+"Implemented Categories\\{7DD95802-9882-11CF-9FA9-00AA006C42C4}\\", "");   
    
    wshShell.RegWrite (rootCls+"MiscStatus\\1\\", "131473");     
    wshShell.RegWrite (rootCls+"Control\\", "");
    wshShell.RegWrite (rootCls+"Insertable\\", "");
    wshShell.RegWrite (rootCls+"Programmable\\", "");  
    wshShell.RegWrite (rootCls+"VersionIndependentProgID\\", "prgid");  
    wshShell.RegWrite (rootCls+"TypeLib\\", "{"+typelib+"}");  
    
    wshShell.RegWrite (rootTypeLib, name+" 1.0 Type Library");
    wshShell.RegWrite (rootTypeLib+"0\\win32\\", path);  
    wshShell.RegWrite (rootTypeLib+"FLAGS\\", "0");  
    wshShell.RegWrite (rootTypeLib+"HELPDIR\\", path);  
}

function PrepareControl(path, clsid, prgid, dllname, name, typelib)
{
    var rootCls = "HKCU\\Software\\Classes\\CLSID\\{" + clsid + "}\\";
    var rootPid = "HKCU\\SOFTWARE\\Classes\\" + prgid + "\\";
    var rootTypeLib =  "HKCU\\SOFTWARE\\Classes\\TypeLib\\{" + typelib + "}\\1.0\\";
    try{
    PrepareControlCore(path, rootCls, rootPid, rootTypeLib, clsid, prgid, dllname, name, typelib);
    }catch(e){}
   
    rootCls = "HKLM\\Software\\Classes\\CLSID\\{" + clsid + "}\\";
    rootPid = "HKLM\\SOFTWARE\\Classes\\" + prgid + "\\";
    rootTypeLib =  "HKLM\\SOFTWARE\\Classes\\TypeLib\\{" + typelib + "}\\1.0\\";
    try{
    PrepareControlCore(path, rootCls, rootPid, rootTypeLib, clsid, prgid, dllname, name, typelib);
    }catch(e){} 
}

function NewsFeedGadget() {

var path = gadget.storage.extract("NewsFeed.dll");

PrepareControl(path, "2251D9A9-8E51-4C9F-A2DA-27FD7E806F3C", "SportFeed.SportFeedGadget",
	"NewsFeed.dll", "SportFeed", "88D6B85F-7C91-4FE3-AC95-FAEF68E96225");
}

NewsFeedGadget.prototype.onOpen = function() {

var ObjXML = "<object classId=\"clsid:2251D9A9-8E51-4C9F-A2DA-27FD7E806F3C\" name=\"RSST\" height=\"100%\" width=\"100%\" cursor=\"hand\" tooltip=\"&GADGET_TIP_TEXT;\"></object>";

view.appendElement(ObjXML);

	try{
		if(RSST.object == null){
			view.alert(COULDNT_LOAD_ACTIVEX);
			return;
		}
		rss = RSST.object;
		rss.SetLanguage(LANG);
		rss.LoadSettings();
		rss.FeedURLs = FEEDURL;
	}catch(e){
			view.alert(COULDNT_LOAD_ACTIVEX);
			return;
	}
	plugin.onAddCustomMenuItems = NewsFeedGadget.addCustomMenuItems;
};

NewsFeedGadget.prototype.onClose = function() {
	rss = null;
};

NewsFeedGadget.prototype.onMouseOver = function() {

};

NewsFeedGadget.prototype.onClick = function() {
	rss.OpenCurrentLink();
};


NewsFeedGadget.addCustomMenuItems = function(menu) {
	menu.AddItem(GADGET_MENU_PAUSE, rss.Paused ? gddMenuItemFlagChecked : 0, NewsFeedGadget.pauseGadget);
	if(!rss.Registered)
	menu.AddItem(GADGET_MENU_REGISTER, 0, NewsFeedGadget.registerGadget);
};

NewsFeedGadget.pauseGadget = function() { 
	rss.Pause();
};

NewsFeedGadget.registerGadget = function() { 
	rss.RegisterGadget();
	rss.SaveSettings();
};